﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;

namespace XamComboEditorTabSelection
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            Data = new ObservableCollection<DataItem>
            {
                new DataItem { ID = 1, Name = "Item 1" },
                new DataItem { ID = 2, Name = "Item 2" },
                new DataItem { ID = 3, Name = "Item 3" },
                new DataItem { ID = 4, Name = "Item 4" },
            };

            DataContext = this;
            xamComboEditor1.SelectedItem = Data[0];
        }

            public ObservableCollection<DataItem> Data { get; set; }
       
            private void xamComboEditor1_GotFocus(object sender, RoutedEventArgs e)
            {
                //search for the SpecializedTextBox element
                SpecializedTextBox text = GetChildFromName(xamComboEditor1, "TextBoxPresenter") as SpecializedTextBox;
                //call the SelectAll method
                text.Dispatcher.BeginInvoke(new Action(() =>
                    {
                        text.SelectAll();
                    }));
            }
        //method for searching the visual tree
            private FrameworkElement GetChildFromName(DependencyObject parent, string name)
            {
                FrameworkElement result = null;

                for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
                {
                    if (VisualTreeHelper.GetChild(parent, i) is FrameworkElement
                        && (VisualTreeHelper.GetChild(parent, i) as FrameworkElement).Name.Equals(name))
                    {
                        return VisualTreeHelper.GetChild(parent, i) as FrameworkElement;
                    }
                    else
                    {
                        result = GetChildFromName(VisualTreeHelper.GetChild(parent, i), name);

                        if (result != null)
                        {
                            break;
                        }
                    }
                }
                return result;
            }
    }
    public class DataItem : INotifyPropertyChanged
    {
        private int id;
        private string name;

        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                Update("ID");
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                Update("Name");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void Update(string prop)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }
    }
   
}
